OpenPersistenceManagerInViewFilter (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.orm.jdo.support

## Class OpenPersistenceManagerInViewFilter

- java.lang.Object
- - org.springframework.web.filter.GenericFilterBean
  - - org.springframework.web.filter.OncePerRequestFilter
    - - org.springframework.orm.jdo.support.OpenPersistenceManagerInViewFilter

- All Implemented Interfaces:
    Filter, Aware, BeanNameAware, DisposableBean, InitializingBean, EnvironmentAware, ServletContextAware

      public class OpenPersistenceManagerInViewFilter
      extends OncePerRequestFilter

  Servlet 2.3 Filter that binds a JDO PersistenceManager to the thread for the entire processing of the request. Intended for the "Open PersistenceManager in View" pattern, i.e. to allow for lazy loading in web views despite the original transactions already being completed.

  This filter makes JDO PersistenceManagers available via the current thread, which will be autodetected by transaction managers. It is suitable for service layer transactions via `JdoTransactionManager` or `JtaTransactionManager` as well as for non-transactional read-only execution.

  Looks up the PersistenceManagerFactory in Spring's root web application context. Supports a "persistenceManagerFactoryBeanName" filter init-param in `web.xml`; the default bean name is "persistenceManagerFactory". Looks up the PersistenceManagerFactory on each request, to avoid initialization order issues (when using ContextLoaderServlet, the root application context will get initialized after this filter).

  Since:
    1.1
  Author:
    Juergen Hoeller
  See Also:
    `OpenPersistenceManagerInViewInterceptor`, `JdoInterceptor`, `JdoTransactionManager`, `PersistenceManagerFactoryUtils.getPersistenceManager(javax.jdo.PersistenceManagerFactory, boolean)`, `TransactionSynchronizationManager`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `DEFAULT_PERSISTENCE_MANAGER_FACTORY_BEAN_NAME`

    - ### Fields inherited from class org.springframework.web.filter.OncePerRequestFilter

      `ALREADY_FILTERED_SUFFIX`

    - ### Fields inherited from class org.springframework.web.filter.GenericFilterBean

      `logger`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `OpenPersistenceManagerInViewFilter()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `doFilterInternal(HttpServletRequest request, HttpServletResponse response, FilterChain filterChain)` Same contract as for `doFilter`, but guaranteed to be just invoked once per request within a single request thread.
    `protected String` | `getPersistenceManagerFactoryBeanName()` Return the bean name of the PersistenceManagerFactory to fetch from Spring's root application context.
    `protected javax.jdo.PersistenceManagerFactory` | `lookupPersistenceManagerFactory()` Look up the PersistenceManagerFactory that this filter should use.
    `protected javax.jdo.PersistenceManagerFactory` | `lookupPersistenceManagerFactory(HttpServletRequest request)` Look up the PersistenceManagerFactory that this filter should use, taking the current HTTP request as argument.
    `void` | `setPersistenceManagerFactoryBeanName(String persistenceManagerFactoryBeanName)` Set the bean name of the PersistenceManagerFactory to fetch from Spring's root application context.

    - ### Methods inherited from class org.springframework.web.filter.OncePerRequestFilter

      `doFilter, getAlreadyFilteredAttributeName, isAsyncDispatch, isAsyncStarted, shouldNotFilter, shouldNotFilterAsyncDispatch, shouldNotFilterErrorDispatch`

    - ### Methods inherited from class org.springframework.web.filter.GenericFilterBean

      `addRequiredProperty, afterPropertiesSet, destroy, getFilterConfig, getFilterName, getServletContext, init, initBeanWrapper, initFilterBean, setBeanName, setEnvironment, setServletContext`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_PERSISTENCE_MANAGER_FACTORY_BEAN_NAME

          public static final String DEFAULT_PERSISTENCE_MANAGER_FACTORY_BEAN_NAME

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### OpenPersistenceManagerInViewFilter

          public OpenPersistenceManagerInViewFilter()

  - ### Method Detail

    - #### setPersistenceManagerFactoryBeanName

          public void setPersistenceManagerFactoryBeanName(String persistenceManagerFactoryBeanName)

      Set the bean name of the PersistenceManagerFactory to fetch from Spring's root application context. Default is "persistenceManagerFactory".
      See Also:
        `DEFAULT_PERSISTENCE_MANAGER_FACTORY_BEAN_NAME`

    - #### getPersistenceManagerFactoryBeanName

          protected String getPersistenceManagerFactoryBeanName()

      Return the bean name of the PersistenceManagerFactory to fetch from Spring's root application context.

    - #### doFilterInternal

          protected void doFilterInternal(HttpServletRequest request,
                              HttpServletResponse response,
                              FilterChain filterChain)
                                   throws ServletException,
                                          IOException

      Description copied from class: `OncePerRequestFilter`
      Same contract as for `doFilter`, but guaranteed to be just invoked once per request within a single request thread. See `OncePerRequestFilter.shouldNotFilterAsyncDispatch()` for details.

      Provides HttpServletRequest and HttpServletResponse arguments instead of the default ServletRequest and ServletResponse ones.

      Specified by:
        `doFilterInternal` in class `OncePerRequestFilter`
      Throws:
        `ServletException`
        `IOException`

    - #### lookupPersistenceManagerFactory

          protected javax.jdo.PersistenceManagerFactory lookupPersistenceManagerFactory(HttpServletRequest request)

      Look up the PersistenceManagerFactory that this filter should use, taking the current HTTP request as argument.

      Default implementation delegates to the `lookupPersistenceManagerFactory` without arguments.

      Returns:
        the PersistenceManagerFactory to use
      See Also:
        `lookupPersistenceManagerFactory()`

    - #### lookupPersistenceManagerFactory

          protected javax.jdo.PersistenceManagerFactory lookupPersistenceManagerFactory()

      Look up the PersistenceManagerFactory that this filter should use. The default implementation looks for a bean with the specified name in Spring's root application context.
      Returns:
        the PersistenceManagerFactory to use
      See Also:
        `getPersistenceManagerFactoryBeanName()`